#version 3.7;

#include "turret.inc"
#include "textures.inc"

global_settings
{
    assumed_gamma 1.2
}

camera
{
    location <.75, 5, -4.5>
    look_at  <.5, 1,  0>
    right 500/285*x
}

light_source { <2, 4, -3> color rgb 1 }

plane
{
    y, 0
    texture
    {
        checker
        texture { Brass_Valley scale 4 }
        texture { Sandalwood }
        rotate <0, 20, 0>
    }
}

object { turret(0, 0, 1) translate <-2, 0, 0> }
object { turret(0, 1, 0) translate <0, 0, 1> }
object { turret(1, 1, 0) translate <2.5, 0, -1.5> }

text
{
    internal 3 "td" .1, 0
    scale 3
    rotate <20, -10, 0>
    texture { Lightning1 scale .2 }
    translate <-1.5, 1, -2>
}

text
{
    internal 1 "(WIP)" .1, 0
    scale .5
    rotate <20, 0, 0>
    pigment { color <1, 0, 0> }
    translate <1, .5, -2>
}
