require "util"

turret_shift = { 0, -.7 }

turret_laser1_folded_animation =
{
    filename = "__td__/graphics/entity/turret/T1-folded.png",
    priority = "medium",
    width = 131,
    height = 72,
    direction_count = 1,
    frame_count = 1,
    shift = turret_shift,
}
turret_laser2_folded_animation = util.table.deepcopy(turret_laser1_folded_animation)
turret_laser2_folded_animation.filename = "__td__/graphics/entity/turret/T2-folded.png"
turret_rocket_folded_animation = util.table.deepcopy(turret_laser1_folded_animation)
turret_rocket_folded_animation.filename = "__td__/graphics/entity/turret/T3-folded.png"
turret_grenade_folded_animation = util.table.deepcopy(turret_laser1_folded_animation)
turret_grenade_folded_animation.filename = "__td__/graphics/entity/turret/T4-folded.png"

turret_laser1_preparing_animation =
{
    filename = "__td__/graphics/entity/turret/T1-preparing.png",
    priority = "medium",
    width = 131,
    height = 72,
    direction_count = 1,
    line_length = 8,
    frame_count = 64,
    axially_symmetrical = false,
    shift = turret_shift,
}
turret_laser2_preparing_animation = util.table.deepcopy(turret_laser1_preparing_animation)
turret_laser2_preparing_animation.filename = "__td__/graphics/entity/turret/T2-preparing.png"
turret_rocket_preparing_animation = util.table.deepcopy(turret_laser1_preparing_animation)
turret_rocket_preparing_animation.filename = "__td__/graphics/entity/turret/T3-preparing.png"
turret_grenade_preparing_animation = util.table.deepcopy(turret_laser1_preparing_animation)
turret_grenade_preparing_animation.filename = "__td__/graphics/entity/turret/T4-preparing.png"

turret_laser1_prepared_animation =
{
    filename = "__td__/graphics/entity/turret/T1-prepared.png",
    priority = "medium",
    width = 131,
    height = 72,
    direction_count = 1,
    frame_count = 1,
    shift = turret_shift,
}
turret_laser2_prepared_animation = util.table.deepcopy(turret_laser1_prepared_animation)
turret_laser2_prepared_animation.filename = "__td__/graphics/entity/turret/T2-prepared.png"
turret_rocket_prepared_animation = util.table.deepcopy(turret_laser1_prepared_animation)
turret_rocket_prepared_animation.filename = "__td__/graphics/entity/turret/T3-prepared.png"
turret_grenade_prepared_animation = util.table.deepcopy(turret_laser1_prepared_animation)
turret_grenade_prepared_animation.filename = "__td__/graphics/entity/turret/T4-prepared.png"

turret_laser1_folding_animation = util.table.deepcopy(turret_laser1_preparing_animation)
turret_laser1_folding_animation.run_mode = "backward"
turret_laser2_folding_animation = util.table.deepcopy(turret_laser2_preparing_animation)
turret_laser2_folding_animation.run_mode = "backward"
turret_rocket_folding_animation = util.table.deepcopy(turret_rocket_preparing_animation)
turret_rocket_folding_animation.run_mode = "backward"
turret_grenade_folding_animation = util.table.deepcopy(turret_grenade_preparing_animation)
turret_grenade_folding_animation.run_mode = "backward"

--doing it like this kinda sucks, but copypasting the whole definition sucks harder
gold_ore = util.table.deepcopy(data.raw["resource"]["copper-ore"])
gold_ore.name = "gold-ore"
gold_ore.minable.hardness = 2.9 --not minable by hand
gold_ore.minable.mining_time = .2
gold_ore.minable.result = "money"
gold_ore.autoplace = nil
gold_ore.map_color = {r=0.803, g=0.800, b=0.215}

coffee_beans = util.table.deepcopy(gold_ore)
coffee_beans.name = "coffee-beans"
coffee_beans.icon = "__td__/graphics/icons/coffee-beans.png"
coffee_beans.minable.mining_time = .1
coffee_beans.minable.mining_particle = "wooden-particle"
coffee_beans.minable.result = "coffee-bean"
coffee_beans.stage_counts = {50, 20, 1}
coffee_beans.stages.filename = "__td__/graphics/entity/coffee-beans.png"
coffee_beans.stages.frame_count = 1
coffee_beans.stages.direction_count = 3
coffee_beans.map_color = {r=0.203, g=0.200, b=0.215}

wallstone = util.table.deepcopy(data.raw["resource"]["stone"])
wallstone.name = "wallstone"
wallstone.minable.hardness = 2.9
wallstone.minable.mining_time = .15
wallstone.minable.result = "stone-wall"
wallstone.autoplace = nil

turret_laser1 = util.table.deepcopy(data.raw["electric-turret"]["laser-turret"])
turret_laser1.name = "turret-laser1"
turret_laser1.icon = "__td__/graphics/icons/turret-laser1.png"
turret_laser1.minable = nil
turret_laser1.energy_source.drain = "0W"
turret_laser1.folded_animation = turret_laser1_folded_animation
turret_laser1.preparing_animation = turret_laser1_preparing_animation
turret_laser1.prepared_animation = turret_laser1_prepared_animation
turret_laser1.folding_animation = turret_laser1_folding_animation
turret_laser1.base_picture = nil
turret_laser1.attack_parameters.cooldown = 80
turret_laser1.attack_parameters.damage = 2
turret_laser1.attack_parameters.range = 10
turret_laser1.attack_parameters.ammo_type.energy_consumption = "0J"

turret_laser2 = util.table.deepcopy(turret_laser1)
turret_laser2.name = "turret-laser2"
turret_laser2.icon = "__td__/graphics/icons/turret-laser2.png"
turret_laser2.rotation_speed = .05
turret_laser2.attack_parameters.cooldown = 20
--turret_laser2.attack_parameters.damage = 2
turret_laser2.attack_parameters.ammo_type.action[1].action_delivery[1].projectile = "blue-laser"
turret_laser2.folded_animation = turret_laser2_folded_animation
turret_laser2.preparing_animation = turret_laser2_preparing_animation
turret_laser2.prepared_animation = turret_laser2_prepared_animation
turret_laser2.folding_animation = turret_laser2_folding_animation

turret_rocket = util.table.deepcopy(turret_laser2)
turret_rocket.name = "turret-rocket"
turret_rocket.icon = "__td__/graphics/icons/turret-rocket.png"
turret_rocket.attack_parameters.cooldown = 80
turret_rocket.attack_parameters.ammo_type.action[1].action_delivery[1].projectile = "rocket"
turret_rocket.folded_animation = turret_rocket_folded_animation
turret_rocket.preparing_animation = turret_rocket_preparing_animation
turret_rocket.prepared_animation = turret_rocket_prepared_animation
turret_rocket.folding_animation = turret_rocket_folding_animation

turret_grenade = util.table.deepcopy(turret_rocket)
turret_grenade.name = "turret-grenade"
turret_grenade.icon = "__td__/graphics/icons/turret-grenade.png"
turret_grenade.attack_parameters.cooldown = 80
turret_grenade.attack_parameters.ammo_type.action[1].action_delivery[1].projectile = "basic-grenade"
turret_grenade.folded_animation = turret_grenade_folded_animation
turret_grenade.preparing_animation = turret_grenade_preparing_animation
turret_grenade.prepared_animation = turret_grenade_prepared_animation
turret_grenade.folding_animation = turret_grenade_folding_animation

td_spawner = util.table.deepcopy(data.raw["unit-spawner"]["biter-spawner"])
td_spawner.name = "td-spawner"
td_spawner.collision_box = nil
td_spawner.max_count_of_owned_units = 0

beer_tank = util.table.deepcopy(data.raw["storage-tank"]["storage-tank"])
beer_tank.name = "beer-tank"
beer_tank.order = "z"

--TODO find a proper way of making buildings not require any energy
td_substation = util.table.deepcopy(data.raw["electric-pole"]["substation"])
td_substation.name = "td-substation"
td_substation.supply_area_distance = 200
td_substation.radius_visualisation_picture.filename = "__td__/graphics/blank.png"
td_substation.order = "a" --no idea why this is needed, but it doesn't work without

td_solar_panel = util.table.deepcopy(data.raw["solar-panel"]["solar-panel"])
td_solar_panel.name = "td-solar-panel"
td_solar_panel.production = "100GW"
td_solar_panel.order = "a"

td_boiler = util.table.deepcopy(data.raw["boiler"]["boiler"])
td_boiler.name = "td-boiler"
td_boiler.energy_consumption = "100MW"
td_boiler.burner.effectivity = 1e99 --ugly, but inf doesn't work here
td_boiler.order = "a"

data:extend({
    gold_ore,
    coffee_beans,
    wallstone,
    turret_laser1,
    turret_laser2,
    turret_rocket,
    turret_grenade,
    beer_tank,
    td_spawner,
    td_substation,
    td_solar_panel,
    td_boiler,
})
